<?xml version='1.0' encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns="http://www.w3.org/1999/xhtml"
 xmlns:d="http://www.dforms.org/1.0">
	<xsl:import href="xbox/XBoxPanel.xsl" />
	<xsl:import href="ybox/YBoxPanel.xsl" />
	<xsl:import href="menu/MenuPanel.xsl" />
	<xsl:import href="combo/ComboPanel.xsl" />
	<xsl:import href="tab/TabPanel.xsl" />

	<xsl:template name="renderPanel" match="*[contains(name(),'-panel')]" mode="x-render">
		<xsl:param name="namespace" /> 
		<xsl:param name="locale" /> 
		<xsl:param name="view" select="."/>
		<xsl:param name="model" />
		<xsl:param name="name"/>
		<xsl:param name="id"/>
		<xsl:param name="default-name"/>
		<xsl:param name="default-id"/>
		<xsl:param name="generated-name"/>
		<xsl:param name="generated-id"/>
		<xsl:param name="ignore-ns-prefix"/>
		<xsl:param name="disabled"/>
		<xsl:param name="params"/>
		<xsl:apply-templates select="$view" mode="render">
			<xsl:with-param name="namespace" select="$namespace"/>
			<xsl:with-param name="locale" select="$locale"/>
			<xsl:with-param name="view" select="$view"/>
			<xsl:with-param name="model" select="$model"/>
			<xsl:with-param name="name" select="$name"/>
			<xsl:with-param name="id" select="$id"/>
			<xsl:with-param name="generated-name" select="$generated-name"/>
			<xsl:with-param name="generated-id" select="$generated-id"/>
			<xsl:with-param name="default-name" select="$default-name"/>
			<xsl:with-param name="default-id" select="$default-id"/>
			<xsl:with-param name="ignore-ns-prefix" select="$ignore-ns-prefix"/>
			<xsl:with-param name="disabled" select="$disabled"/>
			<xsl:with-param name="params" select="$params"/>
		</xsl:apply-templates>
	</xsl:template>
</xsl:stylesheet>